// generated by codegen, do not edit
/**
 * This module provides the generated definition of `BlockExpr`.
 * INTERNAL: Do not import directly.
 */

private import codeql.rust.elements.internal.generated.Synth
private import codeql.rust.elements.internal.generated.Raw
import codeql.rust.elements.Attr
import codeql.rust.elements.internal.LabelableExprImpl::Impl as LabelableExprImpl
import codeql.rust.elements.StmtList

/**
 * INTERNAL: This module contains the fully generated definition of `BlockExpr` and should not
 * be referenced directly.
 */
module Generated {
  /**
   * A block expression. For example:
   * ```rust
   * {
   *     let x = 42;
   * }
   * ```
   * ```rust
   * 'label: {
   *     let x = 42;
   *     x
   * }
   * ```
   * INTERNAL: Do not reference the `Generated::BlockExpr` class directly.
   * Use the subclass `BlockExpr`, where the following predicates are available.
   */
  class BlockExpr extends Synth::TBlockExpr, LabelableExprImpl::LabelableExpr {
    override string getAPrimaryQlClass() { result = "BlockExpr" }

    /**
     * Gets the `index`th attr of this block expression (0-based).
     */
    Attr getAttr(int index) {
      result =
        Synth::convertAttrFromRaw(Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).getAttr(index))
    }

    /**
     * Gets any of the attrs of this block expression.
     */
    final Attr getAnAttr() { result = this.getAttr(_) }

    /**
     * Gets the number of attrs of this block expression.
     */
    final int getNumberOfAttrs() { result = count(int i | exists(this.getAttr(i))) }

    /**
     * Holds if this block expression is async.
     */
    predicate isAsync() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isAsync() }

    /**
     * Holds if this block expression is const.
     */
    predicate isConst() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isConst() }

    /**
     * Holds if this block expression is gen.
     */
    predicate isGen() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isGen() }

    /**
     * Holds if this block expression is move.
     */
    predicate isMove() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isMove() }

    /**
     * Holds if this block expression is try.
     */
    predicate isTry() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isTry() }

    /**
     * Holds if this block expression is unsafe.
     */
    predicate isUnsafe() { Synth::convertBlockExprToRaw(this).(Raw::BlockExpr).isUnsafe() }

    /**
     * Gets the statement list of this block expression, if it exists.
     */
    StmtList getStmtList() {
      result =
        Synth::convertStmtListFromRaw(Synth::convertBlockExprToRaw(this)
              .(Raw::BlockExpr)
              .getStmtList())
    }

    /**
     * Holds if `getStmtList()` exists.
     */
    final predicate hasStmtList() { exists(this.getStmtList()) }
  }
}
